//MQL5 Version  June 21, 2010 Final
//+X================================================================X+
//|                                                CMOSeries_Cls.mqh |
//|                               Copyright  2010, Nikolay Kositsin |
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+X================================================================X+
#property copyright "2010,   Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
#property version   "1.00"

//+X----------------------------------------------------------------X+
//   CMovSeriesTools                                   | 
//+X----------------------------------------------------------------X+ 
#include <MovSeriesTools_Cls.mqh>
//+X================================================================X+
//|         |
//+X================================================================X+
class CCMO : public CMovSeriesTools
 {
public: 
  double     VIDYASeries(uint begin, //     
                          uint prev_calculated, //       
                          uint rates_total, //       
                          int CMO_Length, // CMO 
                          double EMA_Length,
                          double series,  //   ,      bar
                          uint bar,  //  
                          bool set //   .
                          );
                            
  double    CMOSeries(uint begin, //     
                       uint prev_calculated, //       
                       uint rates_total, //       
                       int CMO_Length, // CMO 
                       double series,
                       uint bar,  //  
                       bool set //   .
                       );
  
protected:  
  double    m_dSeriesArray[];
  int       m_Size_, m_count;
  double    m_UpSum_, m_UpSum, m_DnSum_, m_DnSum, m_Vidya, m_Vidya_;
  double    m_AbsCMO_, m_AbsCMO, m_series1, m_series1_, m_SmoothFactor;
 };
//+X================================================================X+
//|  CMOSeries() function                                            |
//+X================================================================X+    
double CCMO::CMOSeries
 (
  uint begin, //     
  uint prev_calculated, //       
  uint rates_total, //       
  int CMO_Length, // CMO 
  double series,  //   ,      bar
  uint bar,  //  
  bool set //   .
 )
// CMOSeries(begin, prev_calculated, rates_total, CMO_Length, series, bar, set) 
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
 {
//----+
  //----      
  if (BarCheck1(begin, bar, set)) return(EMPTY_VALUE);
  
  //----+   ;
  double dseries, abcmo;
  int iii, rrr, size = CMO_Length + 1;
  
  //----+    
  if (bar == begin && !SeriesArrayResize(__FUNCTION__, size, m_dSeriesArray, m_Size_))
    return(EMPTY_VALUE);
  
  //----+    CMO_Length  
  LengthCheck(CMO_Length);

  //----     
  if (BarCheck1(begin + 1, bar, set)) return(EMPTY_VALUE);
  
  //----+    SeriesArray
  Recount_ArrayZeroPos(m_count, size, prev_calculated, series - m_series1, bar, m_dSeriesArray);
   
  //----+  
  if (BarCheck2(begin, bar, set, CMO_Length + 3))
   {         
    m_UpSum = 0.0;
    m_DnSum = 0.0;
    
    for(iii = 1; iii < CMO_Length; iii++)
     {
      rrr = Recount_ArrayNumber(m_count, size, iii);      
      dseries = m_dSeriesArray[rrr];
     
      if (dseries > 0) m_UpSum += dseries;        
      if (dseries < 0) m_DnSum -= dseries;
     } 

    m_AbsCMO = 0.000000001;
   }
  else if (BarCheck3(begin, bar, set, CMO_Length + 3))
   {
    m_series1 = series;
    return(EMPTY_VALUE);
   }             

	 dseries = m_dSeriesArray[m_count];
  if (dseries > 0) m_UpSum += dseries;        
  if (dseries < 0) m_DnSum -= dseries;
  if (m_UpSum + m_DnSum > 0) 
   m_AbsCMO = MathAbs((m_UpSum - m_DnSum) / (m_UpSum + m_DnSum));
   abcmo = m_AbsCMO;                                      
  //----
  rrr = Recount_ArrayNumber(m_count, size, CMO_Length - 1);      
  dseries = m_dSeriesArray[rrr];
  if (dseries > 0) m_UpSum -= dseries;        
  if (dseries < 0) m_DnSum += dseries;
  
  //----+   
  if (BarCheck5(rates_total, bar, set))
   { 
    m_AbsCMO = m_AbsCMO_;
    m_UpSum = m_UpSum_;
    m_DnSum = m_DnSum_;
    m_series1 = m_series1_;
   }
  else m_series1 = series;
  
  //----+   
  if (BarCheck4(rates_total, bar, set))
   {
     m_AbsCMO_ = m_AbsCMO;
    m_UpSum_ = m_UpSum;
    m_DnSum_ = m_DnSum;
    m_series1_ = m_series1;
   }
//----+
  return(abcmo); 
 }
//+X================================================================X+
//|  VIDYASeries() function                                          |
//+X================================================================X+    
double CCMO::VIDYASeries
 (
  uint begin, //     
  uint prev_calculated, //       
  uint rates_total, //       
  int CMO_Length, // CMO 
  double EMA_Length, // EMA 
  double series,  //   ,      bar
  uint bar,  //  
  bool set //   .
 )
// VIDYASeries(begin, prev_calculated, rates_total, CMO_Length, EMA_Length, series, bar, set) 
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
 {
//----+
  //----+   
  double vidya, CMO_ = CMOSeries(begin, prev_calculated, rates_total, CMO_Length, series, bar, set);
 
  //----+  
  if (BarCheck2(begin, bar, set, CMO_Length + 3))
   {             	   
	   m_Vidya = series;
	   //----    
    m_SmoothFactor = 2.0 / (EMA_Length + 1.0);
   }
  else if (BarCheck3(begin, bar, set, CMO_Length + 3)) return(EMPTY_VALUE);             

  //----
  CMO_ *= m_SmoothFactor;                                            
  m_Vidya = CMO_ * series + (1 - CMO_) * m_Vidya;
  vidya = m_Vidya;
  
  //----+   
  if (BarCheck5(rates_total, bar, set))
   { 
    m_Vidya = m_Vidya_;
   }
   
  //----+   
  if (BarCheck4(rates_total, bar, set))
   {
     m_Vidya_ = m_Vidya;
   } 
//----+
  return(vidya); 
 }
//+X----------------------+ <<< The End >>> +-----------------------X+